Flowchart layout in EJ2 JavaScript Diagram control

7 May 202524 minutes to read

The flowchart layout provides a visual representation of processes, workflows, systems, or algorithms in a diagrammatic format. It uses various symbols to depict different actions, with arrows connecting these symbols to indicate the flow or direction of the process. Flowcharts are Essential® tools for illustrating step-by-step sequences, making complex processes easier to understand and communicate.

Common flowchart symbols

Different flowchart symbols have different meanings that are used to represent different states in flowchart. The following table describes the most common flowchart symbols that are used in creating flowchart.

Symbol Shape name Description
Ej2 Diagram displays Terminator Symbol Terminator Indicates the beginning and ending of the process.
Ej2 Diagram displays Data Symbol Data Indicates data input or output for a process.
Ej2 Diagram displays Process Symbol Process Represents an operation or set of operations and data manipulations.
Ej2 Diagram displays Decision Symbol Decision Shows a branching point where the decision is made to choose one of the two paths
Ej2 Diagram displays Document Symbol Document Represents a single document or report in the process.
Ej2 Diagram displays SubProcess Symbol PreDefinedProcess Represents a sequence of actions that combine to perform a specific task that is defined elsewhere.
Ej2 Diagram displays Stored data Symbol StoredData Represents a step where data get stored within a process.
Ej2 Diagram displays internal storage Symbol InternalStorage Represents the internal storage
Ej2 Diagram displays DirectData Symbol DirectData Represents a collection of information that allows searching, sorting, and filtering.
Ej2 Diagram displays SequentialData Symbol SequentialData Represents the data that must be accessed sequentially
Ej2 Diagram displays SequentialData Symbol Sort Represents a step that organizes items list sequentially
Blazor Diagrma displays StoredData Symbol PaperTap Represents a step where data get stored within a process.
Ej2 Diagram displays ManualInput Symbol ManualInput Represents the manual input of data into a field or step in a process.
Ej2 Diagram displays ManualOperation Symbol ManualOperation Represents an operation in a process that must be done manually, not automatically.
Ej2 Diagram displays Preparation Symbol Preparation Represents a setup or initialization process to another step in the process.
Ej2 Diagram displays OffPageReference Symbol OffPageReference Represents a labeled connector used to link two flowcharts on different pages.
Ej2 Diagram displays MultiDocument Symbol MultiDocument Represents multiple documents or reports in the process.
Ej2 Diagram displays card Symbol Card Represents a data card or punched card used for data entry or storage
Ej2 Diagram displays SummingJunction Symbol SummingJunction Represents the logical AND (merge multiple inputs into a single output).
Ej2 Diagram displays Or Symbol Or Represents the logical OR
Ej2 Diagram displays Merge Symbol Merge Represents a step where two or more sub-lists or sub-processes become one.
Ej2 Diagram displays Extract Symbol Extract Represents retrieving or obtaining data from a source for further processing or analysis in a flowchart.
Ej2 Diagram displays delay Symbol Delay Represents the period of delay in a process
Ej2 Diagram displays Collate Symbol Collate Represents the process of gathering and arranging data or documents from multiple sources into a structured format.
Ej2 Diagram displays Annotation Symbol Annotation Represents additional information, clarifications, about a process or decision point in the flowchart.
Ej2 Diagram displays Annotation2 Symbol Annotation2 Represents additional information, or comments about a process in the flowchart.
Ej2 Diagram displays Sequential access storage Symbol SequentialAccessStorage Represents information that is stored in a sequence.
Ej2 Diagram displays Display Symbol Display Represents that the information, data, or output is being shown on a screen or printed for the user’s review.
Ej2 Diagram displays Loop limit Symbol LoopLimit Represents a maximum number of times a particular process or operation can be repeated within a loop.
Ej2 Diagram displays Connector Symbol Connector Represents a direction of flow from one step to another. It will get created automatically based on the relationship between the parent and child.

Render Flowchart layout with data source

To render flowchart layout, you need to set the layoutType property as Flowchart. The following code example displays how to render flowchart layout using data source.

ej.diagrams.Diagram.Inject(ej.diagrams.DataBinding, ej.diagrams.FlowchartLayout);
var data = [
    {
      "id": "1",
      "name": "Start",
      "shape": "Terminator",
      "width": 80,
      "height": 35,
      "color": "#6CA0DC"
    },
    {
      "id": "2",
      "name": "Input",
      "parentId": ["1"],
      "shape": "Parallelogram",
      "width": 90,
      "height": 35,
      "color": "#6CA0DC"
    },
    {
      "id": "3",
      "name": "Decision?",
      "parentId": ["2"],
      "shape": "Decision",
      "width": 80,
      "height": 60,
      "color": "#6CA0DC"
    },
    {
      "id": "4",
      "label": ["No"],
      "name": "Process1",
      "parentId": ["3"],
      "shape": "Process",
      "width": 80,
      "height": 40,
      "color": "#6CA0DC"
    },
    {
      "id": "5",
      "label": ["Yes"],
      "name": "Process2",
      "parentId": ["3"],
      "shape": "Process",
      "width": 80,
      "height": 40,
      "color": "#6CA0DC"
    },
    {
      "id": "6",
      "name": "Output",
      "parentId": ["5"],
      "shape": "Parallelogram",
      "width": 90,
      "height": 35,
      "color": "#6CA0DC"
    },
    {
      "id": "7",
      "name": "Output",
      "parentId": ["4"],
      "shape": "Parallelogram",
      "width": 90,
      "height": 35,
      "color": "#6CA0DC"
    },
    {
      "id": "8",
      "name": "End",
      "parentId": ["6", "7"],
      "shape": "Terminator",
      "width": 80,
      "height": 35,
      "color": "#6CA0DC"
    }
  ];

var items = new ej.data.DataManager(data, new ej.data.Query().take(7));

var diagram = new ej.diagrams.Diagram({
    width: '100%',
    height: '650px',
    //Uses layout to auto-arrange nodes on the diagram page
    layout: {
        //Sets layout type
        type: 'Flowchart'
    },//Configures data source for diagram
    dataSourceSettings: {
        id: 'id',
        parentId: 'parentId',
        dataManager: items
    },//Sets the default properties for nodes
    getNodeDefaults: function (obj) {
        obj.width = 120;
        obj.height = 50;
        if (obj.shape.shape === 'Decision') {
            obj.height = 80;
        }
        return obj;
    }, //Sets the default properties for connectors
    getConnectorDefaults: function (connector) {
        connector.type = 'Orthogonal';
        connector.style.strokeColor = '#6CA0DC';
        connector.targetDecorator.style = {fill: '#6CA0DC', strokeColor: '#6CA0DC'};
        return connector;
    }
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/29.2.4/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

EJ2 Flowchart layout diagram

NOTE

If you want to convert the data source into flowchart layout, you need to inject DataBinding along with FlowchartLayout module in the diagram.

Defining data source with appearance configuration

In the flowchart layout, you can define the desired shape, style, and label for each node, as well as the decorator type for connectors, directly within the data source. The data source should be structured as shown in the example below:

 var Data =  [
        {
            "id": "A",
            "name": "Start",
            "shape": "Terminator",
            "color": "#90EE90",
            "parentId": null,
            "stroke": "#333",
            "strokeWidth": 2
        },
        {
            "id": "B",
            "name": "Process",
            "shape": "Process",
            "color": "#4682B4",
            "parentId": [
                "A"
            ],
            "label":['A-B'],
            "arrowType": "Fletch",
            "stroke": "#333",
            "strokeWidth": 2
        },
    ]

Field Definitions

  • name: Represents the annotation displayed on the node.
  • shape: Defines the shape of the node (e.g., Terminator, Process).
  • color: Specifies the fill color of the node.
  • stroke: Defines the border color of the node.
  • strokeWidth: Specifies the border thickness of the node.
  • label: Adds annotations to the incomming connectors.
  • arrowType: Determines the arrowhead type (decorator) of the incoming connector (e.g., Diamond, Fletch).

This structure allows for easy customization of the flowchart’s visual elements based on the provided data source.

Render Flowchart layout with nodes and connectors

The following example demonstrates how to render a flowchart layout using nodes and connectors. To achieve this, you need to define the nodes and connectors collections and assign them to the diagram. Additionally, you need to set the layoutType to Flowchart.

ej.diagrams.Diagram.Inject(ej.diagrams.FlowchartLayout);
//Initialize nodes
var nodes = [
  { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
  { id: '2', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Input' }], style: { fill: '#6CA0DC' } },
  { id: '3', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
  { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
  { id: '5', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
  { id: '6', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
  { id: '7', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
  { id: '8', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
];
//Initialize connectors
var connectors = [
  { id: 'connector1', sourceID: '1', targetID: '2' },
  { id: 'connector2', sourceID: '2', targetID: '3' },
  { id: 'connector3', sourceID: '3', targetID: '4', annotations: [{ content: 'No' }] },
  { id: 'connector4', sourceID: '3', targetID: '5', annotations: [{ content: 'Yes' }] },
  { id: 'connector5', sourceID: '5', targetID: '6' },
  { id: 'connector6', sourceID: '4', targetID: '7' },
  { id: 'connector7', sourceID: '6', targetID: '8' },
  { id: 'connector8', sourceID: '7', targetID: '8' }
];

var diagram = new ej.diagrams.Diagram({
    width: '100%',
    height: '650px',
    nodes: nodes,
    connectors: connectors,
    //Layout to auto-arrange nodes on the diagram page
    layout: {
        //Sets layout type
        type: 'Flowchart'
    },//Sets the default properties for nodes
    getNodeDefaults: function (obj) {
        obj.width = 120;
        obj.height = 50;
        if (obj.shape.shape === 'Decision') {
            obj.height = 80;
        }
        return obj;
    }, //Sets the default properties for connectors
    getConnectorDefaults: function (connector) {
      connector.type = 'Orthogonal';
      connector.style.strokeColor = '#6CA0DC';
      connector.targetDecorator.style = {fill: '#6CA0DC', strokeColor: '#6CA0DC'};
      return connector;
    }
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/29.2.4/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Customize flowchart layout orientation

The sequence of a node’s direction can be customized by flowchart’s orientation, either vertically from top to bottom or horizontally from left to right. The orientation property of the layout class allows you to define the flow direction for the flowchart as either TopToBottom or LeftToRight. The default orientation is TopToBottom.

TopToBottom orientation

This orientation arranges elements in the layout vertically, flowing from top to bottom. It is commonly used in flowcharts to represent the sequential progression of steps or actions in a process.

//Initialize the diagram
var diagram = new ej.diagrams.Diagram({
  width: '100%',
  height: '645px',
  layout: {
        //Sets layout type
        type: 'Flowchart',
        //Sets the orientation of the layout
        orientation: 'TopToBottom'
    },
});

EJ2 Flowchart layout diagram

LeftToRight orientation

This orientation arranges elements in the layout horizontally, flowing from left to right. It is typically used to represent processes or workflows that move sequentially across the page, emphasizing a linear progression of steps or actions.

//Initialize the diagram
var diagram = new ej.diagrams.Diagram({
  width: '100%',
  height: '645px',
  layout: {
        //Sets layout type
        type: 'Flowchart',
        //Sets the orientation of the layout
        orientation: 'LeftToRight'
    },
});

EJ2 Flowchart layout diagram

Customize the decision output directions

The decision symbol in a flowchart represents a question or condition that leads to different paths based on a binary outcome (Yes/No, True/False). You can customize the output direction of these paths using the yesBranchDirection and noBranchDirection properties of the flowchartLayoutSettings class.

  • LeftInFlow - Arranges the Yes/No branch to the left of the decision symbol.
  • RightInFlow - Arranges the Yes/No branch to the right of the decision symbol.
  • SameAsFlow - Aligns the Yes/No branch in the same direction as the flow of the decision symbol.

The following example shows flowchart layout with yesBranchDirection as SameAsFlow and noBranchDirection as LeftInFlow.

ej.diagrams.Diagram.Inject(ej.diagrams.FlowchartLayout);
//Initialize nodes
var nodes = [
  { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
  { id: '2', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Input' }], style: { fill: '#6CA0DC' } },
  { id: '3', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
  { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
  { id: '5', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
  { id: '6', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
  { id: '7', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
  { id: '8', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
];
//Initialize connectors
var connectors = [
  { id: 'connector1', sourceID: '1', targetID: '2' },
  { id: 'connector2', sourceID: '2', targetID: '3' },
  { id: 'connector3', sourceID: '3', targetID: '4', annotations: [{ content: 'No' }] },
  { id: 'connector4', sourceID: '3', targetID: '5', annotations: [{ content: 'Yes' }] },
  { id: 'connector5', sourceID: '5', targetID: '6' },
  { id: 'connector6', sourceID: '4', targetID: '7' },
  { id: 'connector7', sourceID: '6', targetID: '8' },
  { id: 'connector8', sourceID: '7', targetID: '8' }
];

var diagram = new ej.diagrams.Diagram({
    width: '100%',
    height: '650px',
    nodes: nodes,
    connectors: connectors,
    //Layout to auto-arrange nodes on the diagram page
    layout: {
        //Sets layout type
        type: 'Flowchart',
        //Customizes the flowchart layout
        flowchartLayoutSettings: {
          //Sets the yes branch direction
          yesBranchDirection: 'SameAsFlow',
          //Sets the no branch direction
          noBranchDirection: 'LeftInFlow',
        }
    },//Sets the default properties for nodes
    getNodeDefaults: function (obj) {
        obj.width = 120;
        obj.height = 50;
        if (obj.shape.shape === 'Decision') {
            obj.height = 80;
        }
        return obj;
    }, //Sets the default properties for connectors
    getConnectorDefaults: function (connector) {
      connector.type = 'Orthogonal';
      connector.style.strokeColor = '#6CA0DC';
      connector.targetDecorator.style = {fill: '#6CA0DC', strokeColor: '#6CA0DC'};
      return connector;
    }
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/29.2.4/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

The following table will explain the pictorial representation of the behavior:

YesBranchDirection NoBranchDirection TopToBottom LeftToRight
Left In Flow Right In Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Right In Flow Left In Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Same As Flow Right In Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Same As Flow Left In Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Right In Flow Same As Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Left In Flow Same As Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Same As Flow Same As Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal

NOTE

If both branch directions are same, Yes branch will be prioritized.

Custom Yes and No branch values

The decision symbol produces two output branches: a Yes branch and a No branch. If the connector text value matches any value in the yesBranchValues property of the flowchartLayoutSettings class, it will be considered a Yes branch. Similarly, if the connector text value matches any value in the noBranchValues property, it will be considered a No branch. By default, the yesBranchValues property contains the string values Yes and True, while the noBranchValues property contains No and False.

Any text can be used as the connector text to describe the flow. Additionally, custom string values can be assigned to the yesBranchValues and noBranchValues properties. To direct the flow based on a conditional decision (if/else), the connector text must match a value in either the yesBranchValues or noBranchValues properties.

The following example shows how to set custom text to the yes branch and no branch values.

ej.diagrams.Diagram.Inject(ej.diagrams.FlowchartLayout);
//Initialize nodes
var nodes = [
  { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
  { id: '2', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
  { id: '3', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
  { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
  { id: '5', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
];
//Initialize connectors
var connectors = [
  { id: 'connector1', sourceID: '1', targetID: '2' },
  { id: 'connector2', sourceID: '2', targetID: '3',annotations: [{ content: 'Reject' }]  },
  { id: 'connector3', sourceID: '2', targetID: '4', annotations: [{ content: 'Accept' }] },
  { id: 'connector4', sourceID: '4', targetID: '5', },
];

var diagram = new ej.diagrams.Diagram({
    width: '100%',
    height: '650px',
    nodes: nodes,
    connectors: connectors,
    //Layout to auto-arrange nodes on the diagram page
    layout: {
        //Sets layout type
        type: 'Flowchart',
         //Customizes the flowchart layout
         flowchartLayoutSettings: {
          //Sets the yes branch values
          yesBranchValues: ["Yes", "Accept"],
          //Sets the no branch values
          noBranchValues: ["No", "Reject"]
      }
    },//Sets the default properties for nodes
    getNodeDefaults: function (obj) {
        obj.width = 120;
        obj.height = 50;
        if (obj.shape.shape === 'Decision') {
            obj.height = 80;
        }
        return obj;
    }, //Sets the default properties for connectors
    getConnectorDefaults: function (connector) {
      connector.type = 'Orthogonal';
      connector.style.strokeColor = '#6CA0DC';
      connector.targetDecorator.style = {fill: '#6CA0DC', strokeColor: '#6CA0DC'};
      return connector;
    }
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/29.2.4/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

EJ2 Flowchart layout diagram

Flowchart layout in Vue Diagram control

14 Dec 202424 minutes to read

The flowchart layout provides a visual representation of processes, workflows, systems, or algorithms in a diagrammatic format. It uses various symbols to depict different actions, with arrows connecting these symbols to indicate the flow or direction of the process. Flowcharts are essential tools for illustrating step-by-step sequences, making complex processes easier to understand and communicate.

Common flowchart symbols

Different flowchart symbols have different meanings that are used to represent different states in flowchart. The following table describes the most common flowchart symbols that are used in creating flowchart.

Symbol Shape name Description
Ej2 Diagram displays Terminator Symbol Terminator Indicates the beginning and ending of the process.
Ej2 Diagram displays Data Symbol Data Indicates data input or output for a process.
Ej2 Diagram displays Process Symbol Process Represents an operation or set of operations and data manipulations.
Ej2 Diagram displays Decision Symbol Decision Shows a branching point where the decision is made to choose one of the two paths
Ej2 Diagram displays Document Symbol Document Represents a single document or report in the process.
Ej2 Diagram displays SubProcess Symbol PreDefinedProcess Represents a sequence of actions that combine to perform a specific task that is defined elsewhere.
Ej2 Diagram displays Stored data Symbol StoredData Represents a step where data get stored within a process.
Ej2 Diagram displays internal storage Symbol InternalStorage Represents the internal storage
Ej2 Diagram displays DirectData Symbol DirectData Represents a collection of information that allows searching, sorting, and filtering.
Ej2 Diagram displays SequentialData Symbol SequentialData Represents the data that must be accessed sequentially
Ej2 Diagram displays SequentialData Symbol Sort Represents a step that organizes items list sequentially
Blazor Diagrma displays StoredData Symbol PaperTap Represents a step where data get stored within a process.
Ej2 Diagram displays ManualInput Symbol ManualInput Represents the manual input of data into a field or step in a process.
Ej2 Diagram displays ManualOperation Symbol ManualOperation Represents an operation in a process that must be done manually, not automatically.
Ej2 Diagram displays Preparation Symbol Preparation Represents a setup or initialization process to another step in the process.
Ej2 Diagram displays OffPageReference Symbol OffPageReference Represents a labeled connector used to link two flowcharts on different pages.
Ej2 Diagram displays MultiDocument Symbol MultiDocument Represents multiple documents or reports in the process.
Ej2 Diagram displays card Symbol Card Represents a data card or punched card used for data entry or storage
Ej2 Diagram displays SummingJunction Symbol SummingJunction Represents the logical AND (merge multiple inputs into a single output).
Ej2 Diagram displays Or Symbol Or Represents the logical OR
Ej2 Diagram displays Merge Symbol Merge Represents a step where two or more sub-lists or sub-processes become one.
Ej2 Diagram displays Extract Symbol Extract Represents retrieving or obtaining data from a source for further processing or analysis in a flowchart.
Ej2 Diagram displays delay Symbol Delay Represents the period of delay in a process
Ej2 Diagram displays Collate Symbol Collate Represents the process of gathering and arranging data or documents from multiple sources into a structured format.
Ej2 Diagram displays Annotation Symbol Annotation Represents additional information, clarifications, about a process or decision point in the flowchart.
Ej2 Diagram displays Annotation2 Symbol Annotation2 Represents additional information, or comments about a process in the flowchart.
Ej2 Diagram displays Sequential access storage Symbol SequentialAccessStorage Represents information that is stored in a sequence.
Ej2 Diagram displays Display Symbol Display Represents that the information, data, or output is being shown on a screen or printed for the user’s review.
Ej2 Diagram displays Loop limit Symbol LoopLimit Represents a maximum number of times a particular process or operation can be repeated within a loop.
Ej2 Diagram displays Connector Symbol Connector Represents a direction of flow from one step to another. It will get created automatically based on the relationship between the parent and child.

Render Flowchart layout with data source

To render flowchart layout, you need to set the layoutType property as Flowchart. The following code example displays how to render flowchart layout using data source.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :getNodeDefaults='getNodeDefaults'
            :getConnectorDefaults='getConnectorDefaults' :layout='layout'
            :dataSourceSettings='dataSourceSettings'></ejs-diagram>
    </div>
</template>

<script setup>
import { provide } from "vue";
import { DiagramComponent as EjsDiagram, FlowchartLayout, DataBinding } from '@syncfusion/ej2-vue-diagrams';
import { DataManager, Query } from "@syncfusion/ej2-data";

let data = [
    {
        "id": "1",
        "name": "Start",
        "shape": "Terminator",
        "color": "#6CA0DC"
    },
    {
        "id": "2",
        "name": "Input",
        "parentId": ["1"],
        "shape": "Parallelogram",
        "color": "#6CA0DC"
    },
    {
        "id": "3",
        "name": "Decision?",
        "parentId": ["2"],
        "shape": "Decision",
        "color": "#6CA0DC"
    },
    {
        "id": "4",
        "label": ["No"],
        "name": "Process1",
        "parentId": ["3"],
        "shape": "Process",
        "color": "#6CA0DC"
    },
    {
        "id": "5",
        "label": ["Yes"],
        "name": "Process2",
        "parentId": ["3"],
        "shape": "Process",
        "color": "#6CA0DC"
    },
    {
        "id": "6",
        "name": "Output",
        "parentId": ["5"],
        "shape": "Parallelogram",
        "color": "#6CA0DC"
    },
    {
        "id": "7",
        "name": "Output",
        "parentId": ["4"],
        "shape": "Parallelogram",
        "color": "#6CA0DC"
    },
    {
        "id": "8",
        "name": "End",
        "parentId": ["6", "7"],
        "shape": "Terminator",
        "color": "#6CA0DC"
    }
];

let items = new DataManager(data, new Query().take(7));

const width = "1000px";
const height = "590px";

//Uses layout to auto-arrange nodes on the Diagram page
const layout = {
    //Sets layout type
    type: 'Flowchart',
}

//Initializes the node template.
const dataSourceSettings = {
    id: 'id',
    parentId: 'parentId',
    dataManager: items
}

//Sets the default properties for nodes and connectors
const getNodeDefaults = (node) => {
    node.width = 120; node.height = 50;
    if (node.shape.shape === 'Decision') {
        node.height = 80;
    }
    return node;
}
const getConnectorDefaults = (connector) => {
    connector.type = 'Orthogonal';
    return connector;
}

provide('diagram', [DataBinding, FlowchartLayout]);

</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>
<template>
    <div id="app">
      <ejs-diagram id="diagram" :width='width' :height='height' :getNodeDefaults='getNodeDefaults'
        :getConnectorDefaults='getConnectorDefaults' :layout='layout'
        :dataSourceSettings='dataSourceSettings'></ejs-diagram>
    </div>
  </template>
  
  <script>
  import { DiagramComponent, FlowchartLayout, DataBinding } from '@syncfusion/ej2-vue-diagrams';
  import { DataManager, Query } from "@syncfusion/ej2-data";
  
  let data = [
    {
      "id": "1",
      "name": "Start",
      "shape": "Terminator",
      "color": "#6CA0DC"
    },
    {
      "id": "2",
      "name": "Input",
      "parentId": ["1"],
      "shape": "Parallelogram",
      "color": "#6CA0DC"
    },
    {
      "id": "3",
      "name": "Decision?",
      "parentId": ["2"],
      "shape": "Decision",
      "color": "#6CA0DC"
    },
    {
      "id": "4",
      "label": ["No"],
      "name": "Process1",
      "parentId": ["3"],
      "shape": "Process",
      "color": "#6CA0DC"
    },
    {
      "id": "5",
      "label": ["Yes"],
      "name": "Process2",
      "parentId": ["3"],
      "shape": "Process",
      "color": "#6CA0DC"
    },
    {
      "id": "6",
      "name": "Output",
      "parentId": ["5"],
      "shape": "Parallelogram",
      "color": "#6CA0DC"
    },
    {
      "id": "7",
      "name": "Output",
      "parentId": ["4"],
      "shape": "Parallelogram",
      "color": "#6CA0DC"
    },
    {
      "id": "8",
      "name": "End",
      "parentId": ["6", "7"],
      "shape": "Terminator",
      "color": "#6CA0DC"
    }
  ];
  
  let items = new DataManager(data, new Query().take(7));
  
  export default {
    name: "App",
    components: {
      "ejs-diagram": DiagramComponent
    },
    data() {
      return {
        width: "1000px",
        height: "590px",
  
        //Uses layout to auto-arrange nodes on the Diagram page
        layout: {
          //Sets layout type
          type: 'Flowchart',
        },
  
        //Configures data source for Diagram
        dataSourceSettings: {
          id: 'id',
          parentId: 'parentId',
          dataManager: items
        },
  
        //Sets the default properties for nodes and connectors
        getNodeDefaults: (node) => {
          node.width = 120; node.height = 50;
          if (node.shape.shape === 'Decision') {
            node.height = 80;
          }
          return node;
        },
  
        getConnectorDefaults: (connector) => {
          connector.type = 'Orthogonal';
          return connector;
        }
      }
    },
    provide: {
      diagram: [FlowchartLayout, DataBinding]
    }
  }
  </script>
  
  <style>
  @import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
  </style>

EJ2 Flowchart layout diagram

NOTE

If you want to convert the data source into flowchart layout, you need to inject DataBinding along with FlowchartLayout module in the diagram.

Defining data source with appearance configuration

In the flowchart layout, you can define the desired shape, style, and label for each node, as well as the decorator type for connectors, directly within the data source. The data source should be structured as shown in the example below:

 let Data =  [
        {
            "id": "A",
            "name": "Start",
            "shape": "Terminator",
            "color": "#90EE90",
            "parentId": null,
            "stroke": "#333",
            "strokeWidth": 2
        },
        {
            "id": "B",
            "name": "Process",
            "shape": "Process",
            "color": "#4682B4",
            "parentId": [
                "A"
            ],
            "label":['A-B'],
            "arrowType": "Fletch",
            "stroke": "#333",
            "strokeWidth": 2
        },
    ]

Field Definitions

  • name: Represents the annotation displayed on the node.
  • shape: Defines the shape of the node (e.g., Terminator, Process).
  • color: Specifies the fill color of the node.
  • stroke: Defines the border color of the node.
  • strokeWidth: Specifies the border thickness of the node.
  • label: Adds annotations to the incomming connectors.
  • arrowType: Determines the arrowhead type (decorator) of the incoming connector (e.g., Diamond, Fletch).

This structure allows for easy customization of the flowchart’s visual elements based on the provided data source.

Render Flowchart layout with nodes and connectors

The following example demonstrates how to render a flowchart layout using nodes and connectors. To achieve this, you need to define the nodes and connectors collections and assign them to the diagram. Additionally, you need to set the layoutType to Flowchart.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :connectors='connectors'
            :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults'
            :layout='layout'></ejs-diagram>
    </div>
</template>

<script setup>
import { provide } from "vue";
import { DiagramComponent as EjsDiagram, FlowchartLayout, DataBinding } from '@syncfusion/ej2-vue-diagrams';

//Initialize nodes
let nodes = [
    { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
    { id: '2', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Input' }], style: { fill: '#6CA0DC' } },
    { id: '3', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
    { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
    { id: '5', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
    { id: '6', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '7', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '8', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
];

//Initialize connectors
let connectors = [
    { id: 'connector1', sourceID: '1', targetID: '2' },
    { id: 'connector2', sourceID: '2', targetID: '3' },
    { id: 'connector3', sourceID: '3', targetID: '4', annotations: [{ content: 'No' }] },
    { id: 'connector4', sourceID: '3', targetID: '5', annotations: [{ content: 'Yes' }] },
    { id: 'connector5', sourceID: '5', targetID: '6' },
    { id: 'connector6', sourceID: '4', targetID: '7' },
    { id: 'connector7', sourceID: '6', targetID: '8' },
    { id: 'connector8', sourceID: '7', targetID: '8' }
];

const width = "1000px";
const height = "590px";

//Uses layout to auto-arrange nodes on the Diagram page
const layout = {
    //Sets layout type
    type: 'Flowchart',
}

//Sets the default properties for nodes and connectors
const getNodeDefaults = (node) => {
    node.width = 120; node.height = 50;
    if (node.shape.shape === 'Decision') {
        node.height = 80;
    }
    return node;
}
const getConnectorDefaults = (connector) => {
    connector.type = 'Orthogonal';
    return connector;
}

provide('diagram', [DataBinding, FlowchartLayout]);

</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>
<template>
    <div id="app">
      <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :connectors='connectors'
        :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults' :layout='layout'></ejs-diagram>
    </div>
  </template>
  <script>
  
  import { DiagramComponent, FlowchartLayout, DataBinding } from '@syncfusion/ej2-vue-diagrams';
  
  //Initialize nodes
  let nodes = [
    { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
    { id: '2', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Input' }], style: { fill: '#6CA0DC' } },
    { id: '3', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
    { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
    { id: '5', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
    { id: '6', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '7', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '8', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
  ];
  
  //Initialize connectors
  let connectors = [
    { id: 'connector1', sourceID: '1', targetID: '2' },
    { id: 'connector2', sourceID: '2', targetID: '3' },
    { id: 'connector3', sourceID: '3', targetID: '4', annotations: [{ content: 'No' }] },
    { id: 'connector4', sourceID: '3', targetID: '5', annotations: [{ content: 'Yes' }] },
    { id: 'connector5', sourceID: '5', targetID: '6' },
    { id: 'connector6', sourceID: '4', targetID: '7' },
    { id: 'connector7', sourceID: '6', targetID: '8' },
    { id: 'connector8', sourceID: '7', targetID: '8' }
  ];
  
  export default {
    name: "App",
    components: {
      "ejs-diagram": DiagramComponent
    },
    data() {
      return {
        width: "1000px",
        height: "590px",
        nodes: nodes,
        connectors: connectors,
  
        //Uses layout to auto-arrange nodes on the Diagram page
        layout: {
          //Sets layout type
          type: 'Flowchart',
        },
  
        //Sets the default properties for nodes and connectors
        getNodeDefaults: (node) => {
          node.width = 120; node.height = 50;
          if (node.shape.shape === 'Decision') {
            node.height = 80;
          }
          return node;
        },
  
        getConnectorDefaults: (connector) => {
          connector.type = 'Orthogonal';
          return connector;
        }
      }
    },
    provide: {
      diagram: [FlowchartLayout, DataBinding]
    }
  }
  </script>
  
  <style>
  @import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
  </style>

Customize flowchart layout orientation

The sequence of a node’s direction can be customized by flowchart’s orientation, either vertically from top to bottom or horizontally from left to right. The orientation property of the layout class allows you to define the flow direction for the flowchart as either TopToBottom or LeftToRight. The default orientation is TopToBottom.

TopToBottom orientation

This orientation arranges elements in the layout vertically, flowing from top to bottom. It is commonly used in flowcharts to represent the sequential progression of steps or actions in a process.

  export default {
    name: "App",
    components: {
      "ejs-diagram": DiagramComponent
    },
    data() {
      return {
        width: '100%',
        height: '645px',
        layout: {
                //Sets layout type
                type: 'Flowchart',
                //Sets the orientation of the layout
                orientation: 'TopToBottom'
            },
      };
    }
};

EJ2 Flowchart layout diagram

LeftToRight orientation

This orientation arranges elements in the layout horizontally, flowing from left to right. It is typically used to represent processes or workflows that move sequentially across the page, emphasizing a linear progression of steps or actions.

  export default {
    name: "App",
    components: {
      "ejs-diagram": DiagramComponent
    },
    data() {
      return {
        width: '100%',
        height: '645px',
        layout: {
                //Sets layout type
                type: 'Flowchart',
                //Sets the orientation of the layout
                orientation: 'LeftToRight'
            },
      };
    }
};

EJ2 Flowchart layout diagram

Customize the decision output directions

The decision symbol in a flowchart represents a question or condition that leads to different paths based on a binary outcome (Yes/No, True/False). You can customize the output direction of these paths using the yesBranchDirection and noBranchDirection properties of the flowchartLayoutSettings class.

  • LeftInFlow - Arranges the Yes/No branch to the left of the decision symbol.
  • RightInFlow - Arranges the Yes/No branch to the right of the decision symbol.
  • SameAsFlow - Aligns the Yes/No branch in the same direction as the flow of the decision symbol.

The following example shows flowchart layout with yesBranchDirection as SameAsFlow and noBranchDirection as LeftInFlow.

<template>
    <div id="app">
      <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :connectors='connectors'
        :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults' :layout='layout'></ejs-diagram>
    </div>
  </template>
  
  <script setup>
  import { provide } from "vue";
  import { DiagramComponent as EjsDiagram, FlowchartLayout, DataBinding } from '@syncfusion/ej2-vue-diagrams';
  
  //Initialize nodes
  let nodes = [
    { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
    { id: '2', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Input' }], style: { fill: '#6CA0DC' } },
    { id: '3', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
    { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
    { id: '5', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
    { id: '6', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '7', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '8', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
  ];
  
  //Initialize connectors
  let connectors = [
    { id: 'connector1', sourceID: '1', targetID: '2' },
    { id: 'connector2', sourceID: '2', targetID: '3' },
    { id: 'connector3', sourceID: '3', targetID: '4', annotations: [{ content: 'No' }] },
    { id: 'connector4', sourceID: '3', targetID: '5', annotations: [{ content: 'Yes' }] },
    { id: 'connector5', sourceID: '5', targetID: '6' },
    { id: 'connector6', sourceID: '4', targetID: '7' },
    { id: 'connector7', sourceID: '6', targetID: '8' },
    { id: 'connector8', sourceID: '7', targetID: '8' }
  ];
  
  const width = "1000px";
  const height = "590px";
  
  //Uses layout to auto-arrange nodes on the Diagram page
  const layout = {
    //Sets layout type
    type: 'Flowchart',
  
    //Customizes the flowchart layout
    flowchartLayoutSettings: {
      //Sets the yes branch direction
      yesBranchDirection: 'SameAsFlow',
      //Sets the no branch direction
      noBranchDirection: 'LeftInFlow',
    }
  }
  
  //Sets the default properties for nodes and connectors
  const getNodeDefaults = (node) => {
    node.width = 120; node.height = 50;
    if (node.shape.shape === 'Decision') {
      node.height = 80;
    }
    return node;
  }
  const getConnectorDefaults = (connector) => {
    connector.type = 'Orthogonal';
    return connector;
  }
  
  provide('diagram', [DataBinding, FlowchartLayout]);
  
  </script>
  
  <style>
  @import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
  </style>
<template>
    <div id="app">
      <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :connectors='connectors'
        :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults' :layout='layout'></ejs-diagram>
    </div>
  </template>
  <script>
  
  import { DiagramComponent, FlowchartLayout, DataBinding } from '@syncfusion/ej2-vue-diagrams';
  
  //Initialize nodes
  let nodes = [
    { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
    { id: '2', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Input' }], style: { fill: '#6CA0DC' } },
    { id: '3', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
    { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
    { id: '5', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
    { id: '6', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '7', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '8', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
  ];
  
  //Initialize connectors
  let connectors = [
    { id: 'connector1', sourceID: '1', targetID: '2' },
    { id: 'connector2', sourceID: '2', targetID: '3' },
    { id: 'connector3', sourceID: '3', targetID: '4', annotations: [{ content: 'No' }] },
    { id: 'connector4', sourceID: '3', targetID: '5', annotations: [{ content: 'Yes' }] },
    { id: 'connector5', sourceID: '5', targetID: '6' },
    { id: 'connector6', sourceID: '4', targetID: '7' },
    { id: 'connector7', sourceID: '6', targetID: '8' },
    { id: 'connector8', sourceID: '7', targetID: '8' }
  ];
  
  export default {
    name: "App",
    components: {
      "ejs-diagram": DiagramComponent
    },
    data() {
      return {
        width: "1000px",
        height: "590px",
        nodes: nodes,
        connectors: connectors,
  
        //Uses layout to auto-arrange nodes on the Diagram page
        layout: {
          //Sets layout type
          type: 'Flowchart',
  
          //Customizes the flowchart layout
          flowchartLayoutSettings: {
            //Sets the yes branch direction
            yesBranchDirection: 'SameAsFlow',
            //Sets the no branch direction
            noBranchDirection: 'LeftInFlow',
          }
        },
  
        //Sets the default properties for nodes and connectors
        getNodeDefaults: (node) => {
          node.width = 120; node.height = 50;
          if (node.shape.shape === 'Decision') {
            node.height = 80;
          }
          return node;
        },
  
        getConnectorDefaults: (connector) => {
          connector.type = 'Orthogonal';
          return connector;
        }
      }
    },
    provide: {
      diagram: [FlowchartLayout, DataBinding]
    }
  }
  </script>
  
  <style>
  @import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
  </style>

The following table will explain the pictorial representation of the behavior:

YesBranchDirection NoBranchDirection TopToBottom LeftToRight
Left In Flow Right In Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Right In Flow Left In Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Same As Flow Right In Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Same As Flow Left In Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Right In Flow Same As Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Left In Flow Same As Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Same As Flow Same As Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal

NOTE

If both branch directions are same, Yes branch will be prioritized.

Custom Yes and No branch values

The decision symbol produces two output branches: a Yes branch and a No branch. If the connector text value matches any value in the yesBranchValues property of the flowchartLayoutSettings class, it will be considered a Yes branch. Similarly, if the connector text value matches any value in the noBranchValues property, it will be considered a No branch. By default, the yesBranchValues property contains the string values Yes and True, while the noBranchValues property contains No and False.

Any text can be used as the connector text to describe the flow. Additionally, custom string values can be assigned to the yesBranchValues and noBranchValues properties. To direct the flow based on a conditional decision (if/else), the connector text must match a value in either the yesBranchValues or noBranchValues properties.

The following example shows how to set custom text to the yes branch and no branch values.

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :connectors='connectors'
            :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults'
            :layout='layout'></ejs-diagram>
    </div>
</template>

<script setup>
import { provide } from "vue";
import { DiagramComponent as EjsDiagram, FlowchartLayout, DataBinding } from '@syncfusion/ej2-vue-diagrams';

//Initialize nodes
let nodes = [
    { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
    { id: '2', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
    { id: '3', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
    { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
    { id: '5', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
];

//Initialize connectors
let connectors = [
    { id: 'connector1', sourceID: '1', targetID: '2' },
    { id: 'connector2', sourceID: '2', targetID: '3', annotations: [{ content: 'Reject' }] },
    { id: 'connector3', sourceID: '2', targetID: '4', annotations: [{ content: 'Accept' }] },
    { id: 'connector4', sourceID: '4', targetID: '5', },
];

const width = "1000px";
const height = "590px";

//Uses layout to auto-arrange nodes on the Diagram page
const layout = {
    //Sets layout type
    type: 'Flowchart',

    //Customizes the flowchart layout
    flowchartLayoutSettings: {
        //Sets the yes branch values
        yesBranchValues: ["Yes", "Accept"],
        //Sets the no branch values
        noBranchValues: ["No", "Reject"]
    }
}

//Sets the default properties for nodes and connectors
const getNodeDefaults = (node) => {
    node.width = 120; node.height = 50;
    if (node.shape.shape === 'Decision') {
        node.height = 80;
    }
    return node;
}
const getConnectorDefaults = (connector) => {
    connector.type = 'Orthogonal';
    return connector;
}

provide('diagram', [DataBinding, FlowchartLayout]);

</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :connectors='connectors'
            :getNodeDefaults='getNodeDefaults' :getConnectorDefaults='getConnectorDefaults'
            :layout='layout'></ejs-diagram>
    </div>
</template>
<script>

import { DiagramComponent, FlowchartLayout, DataBinding } from '@syncfusion/ej2-vue-diagrams';

//Initialize nodes
let nodes = [
    { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
    { id: '2', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
    { id: '3', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
    { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
    { id: '5', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
];

//Initialize connectors
let connectors = [
    { id: 'connector1', sourceID: '1', targetID: '2' },
    { id: 'connector2', sourceID: '2', targetID: '3', annotations: [{ content: 'Reject' }] },
    { id: 'connector3', sourceID: '2', targetID: '4', annotations: [{ content: 'Accept' }] },
    { id: 'connector4', sourceID: '4', targetID: '5', },
];

export default {
    name: "App",
    components: {
        "ejs-diagram": DiagramComponent
    },
    data() {
        return {
            width: "1000px",
            height: "590px",
            nodes: nodes,
            connectors: connectors,

            //Uses layout to auto-arrange nodes on the Diagram page
            layout: {
                //Sets layout type
                type: 'Flowchart',

                //Customizes the flowchart layout
                flowchartLayoutSettings: {
                    //Sets the yes branch values
                    yesBranchValues: ["Yes", "Accept"],
                    //Sets the no branch values
                    noBranchValues: ["No", "Reject"]
                }
            },

            //Sets the default properties for nodes and connectors
            getNodeDefaults: (node) => {
                node.width = 120; node.height = 50;
                if (node.shape.shape === 'Decision') {
                    node.height = 80;
                }
                return node;
            },

            getConnectorDefaults: (connector) => {
                connector.type = 'Orthogonal';
                return connector;
            }
        }
    },
    provide: {
        diagram: [FlowchartLayout, DataBinding]
    }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/material.css";
</style>

EJ2 Flowchart layout diagram

HelpBot Assistant

How can I help you?

Flowchart Layout in React Diagram Component

17 Mar 202624 minutes to read

The flowchart layout provides a visual representation of processes, workflows, systems, or algorithms in a diagrammatic format. It uses various symbols to depict different actions, with arrows connecting these symbols to indicate the flow or direction of the process. Flowcharts are Essential® tools for illustrating step-by-step sequences, making complex processes easier to understand and communicate.

Common Flowchart Symbols

Different flowchart symbols have specific meanings used to represent various states and actions in flowcharts. The following table describes the most common flowchart symbols used when creating flowcharts.

Symbol Shape name Description
Terminator Symbol for flowchart start and end points Terminator Indicates the beginning and ending of the process.
Data Symbol for input and output operations Data Indicates data input or output for a process.
Process Symbol for operations and data manipulation Process Represents an operation or set of operations and data manipulations.
Decision Symbol for branching points in flowchart Decision Shows a branching point where the decision is made to choose one of the two paths
Document Symbol for single documents in process Document Represents a single document or report in the process.
PreDefined Process Symbol for defined task sequences PreDefinedProcess Represents a sequence of actions that combine to perform a specific task that is defined elsewhere.
Stored Data Symbol for data storage steps StoredData Represents a step where data get stored within a process.
Internal Storage Symbol for internal data storage InternalStorage Represents the internal storage
Direct Data Symbol for searchable data collections DirectData Represents a collection of information that allows searching, sorting, and filtering.
Sequential Data Symbol for sequential data access SequentialData Represents the data that must be accessed sequentially
Sort Symbol for organizing data sequentially Sort Represents a step that organizes items list sequentially
Paper Tape Symbol for data storage process PaperTap Represents a step where data get stored within a process.
Manual Input Symbol for manual data entry ManualInput Represents the manual input of data into a field or step in a process.
Manual Operation Symbol for manual process steps ManualOperation Represents an operation in a process that must be done manually, not automatically.
Preparation Symbol for setup and initialization Preparation Represents a setup or initialization process to another step in the process.
Off Page Reference Symbol for cross-page connectionsl OffPageReference Represents a labeled connector used to link two flowcharts on different pages.
Multi Document Symbol for multiple documents MultiDocument Represents multiple documents or reports in the process.
Card Symbol for data card operations Card Represents a data card or punched card used for data entry or storage
Summing Junction Symbol for logical AND operations SummingJunction Represents the logical AND (merge multiple inputs into a single output).
Or Symbol for logical OR operations Or Represents the logical OR
Merge Symbol for combining processes Merge Represents a step where two or more sub-lists or sub-processes become one.
Extract Symbol for data retrieval operations Extract Represents retrieving or obtaining data from a source for further processing or analysis in a flowchart.
Delay Symbol for process delays Delay Represents the period of delay in a process
Collate Symbol for data gathering operations Collate Represents the process of gathering and arranging data or documents from multiple sources into a structured format.
Annotation Symbol for additional information Annotation Represents additional information, clarifications, about a process or decision point in the flowchart.
Annotation2 Symbol for comments and notes Annotation2 Represents additional information, or comments about a process in the flowchart.
Sequential Access Storage Symbol for sequential storage SequentialAccessStorage Represents information that is stored in a sequence.
Display Symbol for output presentation Display Represents that the information, data, or output is being shown on a screen or printed for the user’s review.
Loop Limit Symbol for loop constraints LoopLimit Represents a maximum number of times a particular process or operation can be repeated within a loop.
Connector Symbol for flow direction Connector Represents a direction of flow from one step to another. It will get created automatically based on the relationship between the parent and child.

Render Flowchart layout with Data Source

To render a flowchart layout, set the layoutType property to Flowchart. The following code example demonstrates how to render a flowchart layout using a data source.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { DiagramComponent, Inject, DataBinding, FlowchartLayout } from "@syncfusion/ej2-react-diagrams";
import { DataManager, Query } from "@syncfusion/ej2-data";


//Initializes data source
let data = [
    {
        "id": "1",
        "name": "Start",
        "shape": "Terminator",
        "color": "#6CA0DC"
    },
    {
        "id": "2",
        "name": "Input",
        "parentId": ["1"],
        "shape": "Parallelogram",
        "color": "#6CA0DC"
    },
    {
        "id": "3",
        "name": "Decision?",
        "parentId": ["2"],
        "shape": "Decision",
        "color": "#6CA0DC"
    },
    {
        "id": "4",
        "label": ["No"],
        "name": "Process1",
        "parentId": ["3"],
        "shape": "Process",
        "color": "#6CA0DC"
    },
    {
        "id": "5",
        "label": ["Yes"],
        "name": "Process2",
        "parentId": ["3"],
        "shape": "Process",
        "color": "#6CA0DC"
    },
    {
        "id": "6",
        "name": "Output",
        "parentId": ["5"],
        "shape": "Parallelogram",
        "color": "#6CA0DC"
    },
    {
        "id": "7",
        "name": "Output",
        "parentId": ["4"],
        "shape": "Parallelogram",
        "color": "#6CA0DC"
    },
    {
        "id": "8",
        "name": "End",
        "parentId": ["6", "7"],
        "shape": "Terminator",
        "color": "#6CA0DC"
    }
];

let items = new DataManager(data, new Query().take(7));

export default function App() {

    return (
        <div>
            <DiagramComponent
                id="container"
                width={"100%"}
                height={"550px"}

                //Uses layout to auto-arrange nodes on the diagram page
                layout={{
                    //Sets layout type
                    type: 'Flowchart'
                }}

                //Configures data source for diagram
                dataSourceSettings={{
                    id: 'id',
                    parentId: 'parentId',
                    dataSource: items
                }}

                //Sets the default properties for nodes
                getNodeDefaults={(node) => {
                    node.width = 120; node.height = 50;
                    if (node.shape.shape === 'Decision') {
                        node.height = 80;
                    }
                    return node;
                }}

                //Sets the default properties for connectors
                getConnectorDefaults={(connector) => {
                    connector.type = 'Orthogonal';
                    return connector;
                }}
            >

                {/* Inject necessary services for the diagram */}
                <Inject services={[DataBinding, FlowchartLayout]} />
            </DiagramComponent>
        </div>
    );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { DiagramComponent, Inject, NodeModel, ConnectorModel, DataBinding, FlowchartLayout } from "@syncfusion/ej2-react-diagrams";
import { DataManager, Query } from "@syncfusion/ej2-data";


//Initializes data source
let data: object[] = [
  {
    "id": "1",
    "name": "Start",
    "shape": "Terminator",
    "color": "#6CA0DC"
  },
  {
    "id": "2",
    "name": "Input",
    "parentId": ["1"],
    "shape": "Parallelogram",
    "color": "#6CA0DC"
  },
  {
    "id": "3",
    "name": "Decision?",
    "parentId": ["2"],
    "shape": "Decision",
    "color": "#6CA0DC"
  },
  {
    "id": "4",
    "label": ["No"],
    "name": "Process1",
    "parentId": ["3"],
    "shape": "Process",
    "color": "#6CA0DC"
  },
  {
    "id": "5",
    "label": ["Yes"],
    "name": "Process2",
    "parentId": ["3"],
    "shape": "Process",
    "color": "#6CA0DC"
  },
  {
    "id": "6",
    "name": "Output",
    "parentId": ["5"],
    "shape": "Parallelogram",
    "color": "#6CA0DC"
  },
  {
    "id": "7",
    "name": "Output",
    "parentId": ["4"],
    "shape": "Parallelogram",
    "color": "#6CA0DC"
  },
  {
    "id": "8",
    "name": "End",
    "parentId": ["6", "7"],
    "shape": "Terminator",
    "color": "#6CA0DC"
  }
];

let items: DataManager = new DataManager(data as JSON[], new Query().take(7));

export default function App() {

  return (
    <div>
      <DiagramComponent
        id="container"
        width={"100%"}
        height={"550px"}

        //Uses layout to auto-arrange nodes on the diagram page
        layout={{
          //Sets layout type
          type: 'Flowchart'
        }}

        //Configures data source for diagram
        dataSourceSettings={{
          id: 'id',
          parentId: 'parentId',
          dataSource: items
        }}

        //Sets the default properties for nodes
        getNodeDefaults={(node: NodeModel) => {
          node.width = 120; node.height = 50;
          if ((node.shape as any).shape === 'Decision') {
            node.height = 80;
          }
          return node;
        }}

        //Sets the default properties for connectors
        getConnectorDefaults={(connector: ConnectorModel) => {
          connector.type = 'Orthogonal';
          return connector;
        }}
      >

        {/* Inject necessary services for the diagram */}
        <Inject services={[DataBinding, FlowchartLayout]} />
      </DiagramComponent>
    </div>
  );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram") as HTMLElement);
root.render(<App />);

EJ2 Flowchart layout diagram

Note: If you want to convert the data source into flowchart layout, you need to inject DataBinding along with FlowchartLayout module in the diagram.

Configuring Data Source with Appearance Settings

In the flowchart layout, you can define the desired shape, style, and label for each node, as well as the decorator type for connectors, directly within the data source. Structure the data source as shown in the example below:

 var Data =  [
        {
            "id": "A",
            "name": "Start",
            "shape": "Terminator",
            "color": "#90EE90",
            "parentId": null,
            "stroke": "#333",
            "strokeWidth": 2
        },
        {
            "id": "B",
            "name": "Process",
            "shape": "Process",
            "color": "#4682B4",
            "parentId": [
                "A"
            ],
            "label":['A-B'],
            "arrowType": "Fletch",
            "stroke": "#333",
            "strokeWidth": 2
        },
    ]

Data Source Field Definitions

  • name: Text annotation displayed on the node.
  • shape: Node shape type (e.g., Terminator, Process, Decision).
  • color: Fill color for the node background.
  • stroke: Border color of the node.
  • strokeWidth: Border thickness in pixels.
  • label: Annotations for incoming connectors.
  • arrowType: Arrowhead type for incoming connectors (e.g., Diamond, Fletch).

This structure enables comprehensive customization of the flowchart’s visual elements based on the provided data source.

Render Flowchart Layout with Nodes and Connectors

The following example demonstrates how to render a flowchart layout using nodes and connectors. To achieve this, you need to define the nodes and connectors collections and assign them to the diagram. Additionally, you need to set the layoutType to Flowchart.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { DiagramComponent, Inject, DataBinding, FlowchartLayout } from "@syncfusion/ej2-react-diagrams";


  //Initialize nodes for diagram
  let nodes = [
    { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
    { id: '2', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Input' }], style: { fill: '#6CA0DC' } },
    { id: '3', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
    { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
    { id: '5', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
    { id: '6', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '7', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '8', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
  ];

  //Initialize connectors for diagram
  let connectors = [
    { id: 'connector1', sourceID: '1', targetID: '2' },
    { id: 'connector2', sourceID: '2', targetID: '3' },
    { id: 'connector3', sourceID: '3', targetID: '4', annotations: [{ content: 'No' }] },
    { id: 'connector4', sourceID: '3', targetID: '5', annotations: [{ content: 'Yes' }] },
    { id: 'connector5', sourceID: '5', targetID: '6' },
    { id: 'connector6', sourceID: '4', targetID: '7' },
    { id: 'connector7', sourceID: '6', targetID: '8' },
    { id: 'connector8', sourceID: '7', targetID: '8' }
  ];

export default function App() {

    return (
        <div>
            <DiagramComponent
                id="container"
                width={"100%"}
                height={"550px"}
                nodes={nodes}
                connectors={connectors}

                //Uses layout to auto-arrange nodes on the diagram page
                layout={{
                    //Sets layout type
                    type: 'Flowchart'
                }}

                //Sets the default properties for nodes
                getNodeDefaults={(node) => {
                    node.width = 120; node.height = 50;
                    if (node.shape.shape === 'Decision') {
                        node.height = 80;
                    }
                    return node;
                }}

                //Sets the default properties for connectors
                getConnectorDefaults={(connector) => {
                    connector.type = 'Orthogonal';
                    return connector;
                }}
            >

                {/* Inject necessary services for the diagram */}
                <Inject services={[DataBinding, FlowchartLayout]} />
            </DiagramComponent>
        </div>
    );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { DiagramComponent, Inject, NodeModel, ConnectorModel, DataBinding, FlowchartLayout } from "@syncfusion/ej2-react-diagrams";


  //Initialize nodes for diagram
  let nodes: NodeModel[] = [
    { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
    { id: '2', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Input' }], style: { fill: '#6CA0DC' } },
    { id: '3', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
    { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
    { id: '5', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
    { id: '6', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '7', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '8', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
  ];

  //Initialize connectors for diagram
  let connectors: ConnectorModel[] = [
    { id: 'connector1', sourceID: '1', targetID: '2' },
    { id: 'connector2', sourceID: '2', targetID: '3' },
    { id: 'connector3', sourceID: '3', targetID: '4', annotations: [{ content: 'No' }] },
    { id: 'connector4', sourceID: '3', targetID: '5', annotations: [{ content: 'Yes' }] },
    { id: 'connector5', sourceID: '5', targetID: '6' },
    { id: 'connector6', sourceID: '4', targetID: '7' },
    { id: 'connector7', sourceID: '6', targetID: '8' },
    { id: 'connector8', sourceID: '7', targetID: '8' }
  ];

export default function App() {

  return (
    <div>
      <DiagramComponent
        id="container"
        width={"100%"}
        height={"550px"}
        nodes={nodes}
        connectors={connectors}
        
        //Uses layout to auto-arrange nodes on the diagram page
        layout={{
          //Sets layout type
          type: 'Flowchart'
        }}

        //Sets the default properties for nodes
        getNodeDefaults={(node: NodeModel) => {
          node.width = 120; node.height = 50;
          if ((node.shape as any).shape === 'Decision') {
            node.height = 80;
          }
          return node;
        }}

        //Sets the default properties for connectors
        getConnectorDefaults={(connector: ConnectorModel) => {
          connector.type = 'Orthogonal';
          return connector;
        }}
      >

        {/* Inject necessary services for the diagram */}
        <Inject services={[DataBinding, FlowchartLayout]} />
      </DiagramComponent>
    </div>
  );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram") as HTMLElement);
root.render(<App />);

Customize Flowchart Layout Orientation

Customize the flow direction of the flowchart using the orientation property of the layout class. The flowchart can flow either vertically from top to bottom or horizontally from left to right. The default orientation is TopToBottom.

TopToBottom Orientation

This orientation arranges elements vertically, flowing from top to bottom. It is commonly used in flowcharts to represent the sequential progression of steps or actions in a process.

//Initialize the diagram
<ejs-diagram #diagram id="diagram" width="100%" height="600px" [layout]="layout"> </ejs-diagram>

export class AppComponent {
  @ViewChild("diagram")
  public diagram!: DiagramComponent;
  public layout?: LayoutModel;
  ngOnInit(): void {
    this.layout = {
        //Sets layout type
        type: 'Flowchart',
        //Sets the orientation of the layout
        orientation: 'TopToBottom'
    },
  }
};

Flowchart layout with top to bottom orientation

LeftToRight Orientation

This orientation arranges elements in the layout horizontally, flowing from left to right. It is typically used to represent processes or workflows that move sequentially across the page, emphasizing a linear progression of steps or actions.

//Initialize the diagram
<ejs-diagram #diagram id="diagram" width="100%" height="600px" [layout]="layout"> </ejs-diagram>

export class AppComponent {
  @ViewChild("diagram")
  public diagram!: DiagramComponent;
  public layout?: LayoutModel;
  ngOnInit(): void {
    this.layout = {
        //Sets layout type
        type: 'Flowchart',
        //Sets the orientation of the layout
        orientation: 'LeftToRight'
    },
  }
};

Flowchart layout with left to right orientation

Customize the Decision Output Directions

The decision symbol in a flowchart represents a question or condition that leads to different paths based on a binary outcome (Yes/No, True/False). You can customize the output direction of these paths using the yesBranchDirection and noBranchDirection properties of the flowchartLayoutSettings class.

Branch Direction Options

  • LeftInFlow - Arranges the Yes/No branch to the left of the decision symbol.
  • RightInFlow - Arranges the Yes/No branch to the right of the decision symbol.
  • SameAsFlow - Aligns the Yes/No branch in the same direction as the flow of the decision symbol.

The following example shows a flowchart layout with yesBranchDirection set to SameAsFlow and noBranchDirection set to LeftInFlow.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { DiagramComponent, Inject, DataBinding, FlowchartLayout } from "@syncfusion/ej2-react-diagrams";


//Initialize nodes for diagram
let nodes = [
    { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
    { id: '2', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Input' }], style: { fill: '#6CA0DC' } },
    { id: '3', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
    { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
    { id: '5', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
    { id: '6', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '7', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '8', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
];

//Initialize connectors for diagram
let connectors = [
    { id: 'connector1', sourceID: '1', targetID: '2' },
    { id: 'connector2', sourceID: '2', targetID: '3' },
    { id: 'connector3', sourceID: '3', targetID: '4', annotations: [{ content: 'No' }] },
    { id: 'connector4', sourceID: '3', targetID: '5', annotations: [{ content: 'Yes' }] },
    { id: 'connector5', sourceID: '5', targetID: '6' },
    { id: 'connector6', sourceID: '4', targetID: '7' },
    { id: 'connector7', sourceID: '6', targetID: '8' },
    { id: 'connector8', sourceID: '7', targetID: '8' }
];

export default function App() {

    return (
        <div>
            <DiagramComponent
                id="container"
                width={"100%"}
                height={"550px"}
                nodes={nodes}
                connectors={connectors}

                //Uses layout to auto-arrange nodes on the diagram page
                layout={{
                    //Sets layout type
                    type: 'Flowchart',

                    //Customizes the flowchart layout
                    flowchartLayoutSettings: {
                        //Sets the yes branch direction
                        yesBranchDirection: 'SameAsFlow',
                        //Sets the no branch direction
                        noBranchDirection: 'LeftInFlow',
                    }
                }}

                //Sets the default properties for nodes
                getNodeDefaults={(node) => {
                    node.width = 120; node.height = 50;
                    if (node.shape.shape === 'Decision') {
                        node.height = 80;
                    }
                    return node;
                }}

                //Sets the default properties for connectors
                getConnectorDefaults={(connector) => {
                    connector.type = 'Orthogonal';
                    return connector;
                }}
            >

                {/* Inject necessary services for the diagram */}
                <Inject services={[DataBinding, FlowchartLayout]} />
            </DiagramComponent>
        </div>
    );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { DiagramComponent, Inject, NodeModel, ConnectorModel, DataBinding, FlowchartLayout } from "@syncfusion/ej2-react-diagrams";


//Initialize nodes for diagram
let nodes: NodeModel[] = [
  { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
  { id: '2', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Input' }], style: { fill: '#6CA0DC' } },
  { id: '3', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
  { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
  { id: '5', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
  { id: '6', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
  { id: '7', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
  { id: '8', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
];

//Initialize connectors for diagram
let connectors: ConnectorModel[] = [
  { id: 'connector1', sourceID: '1', targetID: '2' },
  { id: 'connector2', sourceID: '2', targetID: '3' },
  { id: 'connector3', sourceID: '3', targetID: '4', annotations: [{ content: 'No' }] },
  { id: 'connector4', sourceID: '3', targetID: '5', annotations: [{ content: 'Yes' }] },
  { id: 'connector5', sourceID: '5', targetID: '6' },
  { id: 'connector6', sourceID: '4', targetID: '7' },
  { id: 'connector7', sourceID: '6', targetID: '8' },
  { id: 'connector8', sourceID: '7', targetID: '8' }
];

export default function App() {

  return (
    <div>
      <DiagramComponent
        id="container"
        width={"100%"}
        height={"550px"}
        nodes={nodes}
        connectors={connectors}

        //Uses layout to auto-arrange nodes on the diagram page
        layout={{
          //Sets layout type
          type: 'Flowchart',

          //Customizes the flowchart layout
          flowchartLayoutSettings: {
            //Sets the yes branch direction
            yesBranchDirection: 'SameAsFlow',
            //Sets the no branch direction
            noBranchDirection: 'LeftInFlow',
          }
        }}

        //Sets the default properties for nodes
        getNodeDefaults={(node: NodeModel) => {
          node.width = 120; node.height = 50;
          if ((node.shape as any).shape === 'Decision') {
            node.height = 80;
          }
          return node;
        }}

        //Sets the default properties for connectors
        getConnectorDefaults={(connector: ConnectorModel) => {
          connector.type = 'Orthogonal';
          return connector;
        }}
      >

        {/* Inject necessary services for the diagram */}
        <Inject services={[DataBinding, FlowchartLayout]} />
      </DiagramComponent>
    </div>
  );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram") as HTMLElement);
root.render(<App />);

The following table illustrates the visual behavior of different branch direction combinations:

YesBranchDirection NoBranchDirection TopToBottom LeftToRight
Left In Flow Right In Flow Decision output with left yes and right no branches in vertical layout Decision output with left yes and right no branches in horizontal layout
Right In Flow Left In Flow Decision output with right yes and left no branches in vertical layout Decision output with right yes and left no branches in horizontal layout
Same As Flow Right In Flow Decision output with same flow yes and right no branches in vertical layout Decision output with same flow yes and right no branches in horizontal layout
Same As Flow Left In Flow Decision output with same flow yes and left no branches in vertical layout Decision output with same flow yes and left no branches in horizontal layout
Right In Flow Same As Flow Decision output with right yes and same flow no branches in vertical layout Decision output with right yes and same flow no branches in horizontal layout
Left In Flow Same As Flow Decision output with left yes and same flow no branches in vertical layout Decision output with left yes and same flow no branches in horizontal layout
Same As Flow Same As Flow Decision output with both branches in same flow direction in vertical layout Decision output with both branches in same flow direction in horizontal layout

Note: When both branch directions are set to the same value, the Yes branch takes priority in positioning.

Custom Yes and No Branch Values

The decision symbol produces two output branches: a Yes branch and a No branch. Configure custom text values to determine branch classification using the yesBranchValues property of the flowchartLayoutSettings class, it will be considered a Yes branch. Similarly, if the connector text value matches any value in the noBranchValues.

By default:

  • yesBranchValues contains: “Yes” and “True”.
  • noBranchValues contains: “No” and “False”.

Custom Branch Classification

When a connector’s text value matches any value in the yesBranchValues array, it is classified as a Yes branch. Similarly, when the connector text matches any value in the noBranchValues array, it is classified as a No branch. This enables flexible decision flow control using custom terminology appropriate for your specific use case.

The following example demonstrates how to set custom text values for yes and no branches.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { DiagramComponent, Inject, DataBinding, FlowchartLayout } from "@syncfusion/ej2-react-diagrams";


//Initialize nodes for diagram
let nodes = [
    { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
    { id: '2', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
    { id: '3', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
    { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
    { id: '5', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
  ];

//Initialize connectors for diagram
let connectors = [
    { id: 'connector1', sourceID: '1', targetID: '2' },
    { id: 'connector2', sourceID: '2', targetID: '3', annotations: [{ content: 'Reject' }] },
    { id: 'connector3', sourceID: '2', targetID: '4', annotations: [{ content: 'Accept' }] },
    { id: 'connector4', sourceID: '4', targetID: '5', },
  ];

export default function App() {

    return (
        <div>
            <DiagramComponent
                id="container"
                width={"100%"}
                height={"550px"}
                nodes={nodes}
                connectors={connectors}

                //Uses layout to auto-arrange nodes on the diagram page
                layout={{
                    //Sets layout type
                    type: 'Flowchart',

                    //Customizes the flowchart layout
                    flowchartLayoutSettings: {
                        //Sets the yes branch values
                        yesBranchValues: ["Yes", "Accept"],
                        //Sets the no branch values
                        noBranchValues: ["No", "Reject"]
                    }
                }}

                //Sets the default properties for nodes
                getNodeDefaults={(node) => {
                    node.width = 120; node.height = 50;
                    if (node.shape.shape === 'Decision') {
                        node.height = 80;
                    }
                    return node;
                }}

                //Sets the default properties for connectors
                getConnectorDefaults={(connector) => {
                    connector.type = 'Orthogonal';
                    return connector;
                }}
            >

                {/* Inject necessary services for the diagram */}
                <Inject services={[DataBinding, FlowchartLayout]} />
            </DiagramComponent>
        </div>
    );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { DiagramComponent, Inject, NodeModel, ConnectorModel, DataBinding, FlowchartLayout } from "@syncfusion/ej2-react-diagrams";


//Initialize nodes for diagram
let nodes: NodeModel[] = [
  { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
  { id: '2', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
  { id: '3', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
  { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
  { id: '5', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
];

//Initialize connectors for diagram
let connectors: ConnectorModel[] = [
  { id: 'connector1', sourceID: '1', targetID: '2' },
  { id: 'connector2', sourceID: '2', targetID: '3', annotations: [{ content: 'Reject' }] },
  { id: 'connector3', sourceID: '2', targetID: '4', annotations: [{ content: 'Accept' }] },
  { id: 'connector4', sourceID: '4', targetID: '5', },
];

export default function App() {

  return (
    <div>
      <DiagramComponent
        id="container"
        width={"100%"}
        height={"550px"}
        nodes={nodes}
        connectors={connectors}

        //Uses layout to auto-arrange nodes on the diagram page
        layout={{
          //Sets layout type
          type: 'Flowchart',

          //Customizes the flowchart layout
          flowchartLayoutSettings: {
            //Sets the yes branch values
            yesBranchValues: ["Yes", "Accept"],
            //Sets the no branch values
            noBranchValues: ["No", "Reject"]
          }
        }}

        //Sets the default properties for nodes
        getNodeDefaults={(node: NodeModel) => {
          node.width = 120; node.height = 50;
          if ((node.shape as any).shape === 'Decision') {
            node.height = 80;
          }
          return node;
        }}

        //Sets the default properties for connectors
        getConnectorDefaults={(connector: ConnectorModel) => {
          connector.type = 'Orthogonal';
          return connector;
        }}
      >

        {/* Inject necessary services for the diagram */}
        <Inject services={[DataBinding, FlowchartLayout]} />
      </DiagramComponent>
    </div>
  );
}

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram") as HTMLElement);
root.render(<App />);

Flowchart layout with custom yes and no branch values

Flowchart layout in Angular Diagram control

10 Dec 202424 minutes to read

The flowchart layout provides a visual representation of processes, workflows, systems, or algorithms in a diagrammatic format. It uses various symbols to depict different actions, with arrows connecting these symbols to indicate the flow or direction of the process. Flowcharts are essential tools for illustrating step-by-step sequences, making complex processes easier to understand and communicate.

Common flowchart symbols

Different flowchart symbols have different meanings that are used to represent different states in flowchart. The following table describes the most common flowchart symbols that are used in creating flowchart.

Symbol Shape name Description
Ej2 Diagram displays Terminator Symbol Terminator Indicates the beginning and ending of the process.
Ej2 Diagram displays Data Symbol Data Indicates data input or output for a process.
Ej2 Diagram displays Process Symbol Process Represents an operation or set of operations and data manipulations.
Ej2 Diagram displays Decision Symbol Decision Shows a branching point where the decision is made to choose one of the two paths
Ej2 Diagram displays Document Symbol Document Represents a single document or report in the process.
Ej2 Diagram displays SubProcess Symbol PreDefinedProcess Represents a sequence of actions that combine to perform a specific task that is defined elsewhere.
Ej2 Diagram displays Stored data Symbol StoredData Represents a step where data get stored within a process.
Ej2 Diagram displays internal storage Symbol InternalStorage Represents the internal storage
Ej2 Diagram displays DirectData Symbol DirectData Represents a collection of information that allows searching, sorting, and filtering.
Ej2 Diagram displays SequentialData Symbol SequentialData Represents the data that must be accessed sequentially
Ej2 Diagram displays SequentialData Symbol Sort Represents a step that organizes items list sequentially
Blazor Diagrma displays StoredData Symbol PaperTap Represents a step where data get stored within a process.
Ej2 Diagram displays ManualInput Symbol ManualInput Represents the manual input of data into a field or step in a process.
Ej2 Diagram displays ManualOperation Symbol ManualOperation Represents an operation in a process that must be done manually, not automatically.
Ej2 Diagram displays Preparation Symbol Preparation Represents a setup or initialization process to another step in the process.
Ej2 Diagram displays OffPageReference Symbol OffPageReference Represents a labeled connector used to link two flowcharts on different pages.
Ej2 Diagram displays MultiDocument Symbol MultiDocument Represents multiple documents or reports in the process.
Ej2 Diagram displays card Symbol Card Represents a data card or punched card used for data entry or storage
Ej2 Diagram displays SummingJunction Symbol SummingJunction Represents the logical AND (merge multiple inputs into a single output).
Ej2 Diagram displays Or Symbol Or Represents the logical OR
Ej2 Diagram displays Merge Symbol Merge Represents a step where two or more sub-lists or sub-processes become one.
Ej2 Diagram displays Extract Symbol Extract Represents retrieving or obtaining data from a source for further processing or analysis in a flowchart.
Ej2 Diagram displays delay Symbol Delay Represents the period of delay in a process
Ej2 Diagram displays Collate Symbol Collate Represents the process of gathering and arranging data or documents from multiple sources into a structured format.
Ej2 Diagram displays Annotation Symbol Annotation Represents additional information, clarifications, about a process or decision point in the flowchart.
Ej2 Diagram displays Annotation2 Symbol Annotation2 Represents additional information, or comments about a process in the flowchart.
Ej2 Diagram displays Sequential access storage Symbol SequentialAccessStorage Represents information that is stored in a sequence.
Ej2 Diagram displays Display Symbol Display Represents that the information, data, or output is being shown on a screen or printed for the user’s review.
Ej2 Diagram displays Loop limit Symbol LoopLimit Represents a maximum number of times a particular process or operation can be repeated within a loop.
Ej2 Diagram displays Connector Symbol Connector Represents a direction of flow from one step to another. It will get created automatically based on the relationship between the parent and child.

Render Flowchart layout with data source

To render flowchart layout, you need to set the layoutType property as Flowchart. The following code example displays how to render flowchart layout using data source.

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, DiagramModule, DataBindingService, FlowchartLayoutService, NodeModel,
  ConnectorModel, Diagram, DataBinding, LayoutModel, FlowchartLayout } from '@syncfusion/ej2-angular-diagrams';
import { DataManager, Query } from '@syncfusion/ej2-data';

Diagram.Inject(DataBinding, FlowchartLayout);

@Component({
  imports: [DiagramModule],

  providers: [FlowchartLayoutService, DataBindingService],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="650px" [getNodeDefaults]='nodeDefaults' 
  [getConnectorDefaults]='connectorDefaults' [layout]='layout' [dataSourceSettings]='dataSource' ></ejs-diagram>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  @ViewChild('diagram')
  public diagram!: DiagramComponent;

  //Initializes data source
  public data: Object[] =
    [
      {
        "id": "1",
        "name": "Start",
        "shape": "Terminator",
        "color": "#6CA0DC"
      },
      {
        "id": "2",
        "name": "Input",
        "parentId": ["1"],
        "shape": "Parallelogram",
        "color": "#6CA0DC"
      },
      {
        "id": "3",
        "name": "Decision?",
        "parentId": ["2"],
        "shape": "Decision",
        "color": "#6CA0DC"
      },
      {
        "id": "4",
        "label": ["No"],
        "name": "Process1",
        "parentId": ["3"],
        "shape": "Process",
        "color": "#6CA0DC"
      },
      {
        "id": "5",
        "label": ["Yes"],
        "name": "Process2",
        "parentId": ["3"],
        "shape": "Process",
        "color": "#6CA0DC"
      },
      {
        "id": "6",
        "name": "Output",
        "parentId": ["5"],
        "shape": "Parallelogram",
        "color": "#6CA0DC"
      },
      {
        "id": "7",
        "name": "Output",
        "parentId": ["4"],
        "shape": "Parallelogram",
        "color": "#6CA0DC"
      },
      {
        "id": "8",
        "name": "End",
        "parentId": ["6", "7"],
        "shape": "Terminator",
        "color": "#6CA0DC"
      }
    ]

  //Configures data source for Diagram
  public dataSource: Object = {
    id: 'id', parentId: 'parentId',
    dataManager: new DataManager(this.data as JSON[], new Query().take(7))
  };

  //Sets the default properties for all the Nodes
  public nodeDefaults(node: NodeModel): NodeModel {
    node.width = 120; node.height = 50;
    if ((node.shape as any).shape === 'Decision') {
      node.height = 80;
    }
    return node;
  };

  //Sets the default properties for all the Connector
  public connectorDefaults(connector: ConnectorModel): ConnectorModel {
    connector.type = 'Orthogonal';
    return connector;
  };

  //Uses layout to auto-arrange nodes on the Diagram page
  public layout: LayoutModel = {
    //Sets layout type
    type: 'Flowchart',
  };

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

EJ2 Flowchart layout diagram

NOTE

If you want to convert the data source into flowchart layout, you need to inject DataBinding along with FlowchartLayout module in the diagram.

Defining data source with appearance configuration

In the flowchart layout, you can define the desired shape, style, and label for each node, as well as the decorator type for connectors, directly within the data source. The data source should be structured as shown in the example below:

 var Data =  [
        {
            "id": "A",
            "name": "Start",
            "shape": "Terminator",
            "color": "#90EE90",
            "parentId": null,
            "stroke": "#333",
            "strokeWidth": 2
        },
        {
            "id": "B",
            "name": "Process",
            "shape": "Process",
            "color": "#4682B4",
            "parentId": [
                "A"
            ],
            "label":['A-B'],
            "arrowType": "Fletch",
            "stroke": "#333",
            "strokeWidth": 2
        },
    ]

Field Definitions

  • name: Represents the annotation displayed on the node.
  • shape: Defines the shape of the node (e.g., Terminator, Process).
  • color: Specifies the fill color of the node.
  • stroke: Defines the border color of the node.
  • strokeWidth: Specifies the border thickness of the node.
  • label: Adds annotations to the incomming connectors.
  • arrowType: Determines the arrowhead type (decorator) of the incoming connector (e.g., Diamond, Fletch).

This structure allows for easy customization of the flowchart’s visual elements based on the provided data source.

Render Flowchart layout with nodes and connectors

The following example demonstrates how to render a flowchart layout using nodes and connectors. To achieve this, you need to define the nodes and connectors collections and assign them to the diagram. Additionally, you need to set the layoutType to Flowchart.

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, DiagramModule, DataBindingService, FlowchartLayoutService, NodeModel,
  ConnectorModel, Diagram, DataBinding, LayoutModel, FlowchartLayout } from '@syncfusion/ej2-angular-diagrams';

Diagram.Inject(DataBinding, FlowchartLayout);

@Component({
  imports: [DiagramModule],

  providers: [FlowchartLayoutService, DataBindingService],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="650px"
  [nodes]='nodes' [connectors]='connectors' [getNodeDefaults]='nodeDefaults'
    [getConnectorDefaults]='connectorDefaults' [layout]='layout' ></ejs-diagram>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  @ViewChild('diagram')
  public diagram!: DiagramComponent;

  //Initialize nodes
  public nodes = [
    { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
    { id: '2', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Input' }], style: { fill: '#6CA0DC' } },
    { id: '3', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
    { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
    { id: '5', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
    { id: '6', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '7', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '8', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
  ];
  //Initialize connectors
  public connectors = [
    { id: 'connector1', sourceID: '1', targetID: '2' },
    { id: 'connector2', sourceID: '2', targetID: '3' },
    { id: 'connector3', sourceID: '3', targetID: '4', annotations: [{ content: 'No' }] },
    { id: 'connector4', sourceID: '3', targetID: '5', annotations: [{ content: 'Yes' }] },
    { id: 'connector5', sourceID: '5', targetID: '6' },
    { id: 'connector6', sourceID: '4', targetID: '7' },
    { id: 'connector7', sourceID: '6', targetID: '8' },
    { id: 'connector8', sourceID: '7', targetID: '8' }
  ];


  //Sets the default properties for all the Nodes
  public nodeDefaults(node: NodeModel): NodeModel {
    node.width = 120; node.height = 50;
    if ((node.shape as any).shape === 'Decision') {
      node.height = 80;
    }
    return node;
  };

  //Sets the default properties for all the Connector
  public connectorDefaults(connector: ConnectorModel): ConnectorModel {
    connector.type = 'Orthogonal';
    return connector;
  };

  //Uses layout to auto-arrange nodes on the Diagram page
  public layout: LayoutModel = {
    //Sets layout type
    type: 'Flowchart',
  };

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customize flowchart layout orientation

The sequence of a node’s direction can be customized by flowchart’s orientation, either vertically from top to bottom or horizontally from left to right. The orientation property of the layout class allows you to define the flow direction for the flowchart as either TopToBottom or LeftToRight. The default orientation is TopToBottom.

TopToBottom orientation

This orientation arranges elements in the layout vertically, flowing from top to bottom. It is commonly used in flowcharts to represent the sequential progression of steps or actions in a process.

//Initialize the diagram
<ejs-diagram #diagram id="diagram" width="100%" height="600px" [layout]="layout"> </ejs-diagram>

export class AppComponent {
  @ViewChild("diagram")
  public diagram!: DiagramComponent;
  public layout?: LayoutModel;
  ngOnInit(): void {
    this.layout = {
        //Sets layout type
        type: 'Flowchart',
        //Sets the orientation of the layout
        orientation: 'TopToBottom'
    },
  }
};

EJ2 Flowchart layout diagram

LeftToRight orientation

This orientation arranges elements in the layout horizontally, flowing from left to right. It is typically used to represent processes or workflows that move sequentially across the page, emphasizing a linear progression of steps or actions.

//Initialize the diagram
<ejs-diagram #diagram id="diagram" width="100%" height="600px" [layout]="layout"> </ejs-diagram>

export class AppComponent {
  @ViewChild("diagram")
  public diagram!: DiagramComponent;
  public layout?: LayoutModel;
  ngOnInit(): void {
    this.layout = {
        //Sets layout type
        type: 'Flowchart',
        //Sets the orientation of the layout
        orientation: 'LeftToRight'
    },
  }
};

EJ2 Flowchart layout diagram

Customize the decision output directions

The decision symbol in a flowchart represents a question or condition that leads to different paths based on a binary outcome (Yes/No, True/False). You can customize the output direction of these paths using the yesBranchDirection and noBranchDirection properties of the flowchartLayoutSettings class.

  • LeftInFlow - Arranges the Yes/No branch to the left of the decision symbol.
  • RightInFlow - Arranges the Yes/No branch to the right of the decision symbol.
  • SameAsFlow - Aligns the Yes/No branch in the same direction as the flow of the decision symbol.

The following example shows flowchart layout with yesBranchDirection as SameAsFlow and noBranchDirection as LeftInFlow.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { } from '@syncfusion/ej2-angular-diagrams'


import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, DiagramModule, DataBindingService, FlowchartLayoutService, NodeModel,
  ConnectorModel, Diagram, DataBinding, LayoutModel, FlowchartLayout } from '@syncfusion/ej2-angular-diagrams';

Diagram.Inject(DataBinding, FlowchartLayout);

@Component({
  imports: [DiagramModule],

  providers: [FlowchartLayoutService, DataBindingService],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="650px" [nodes]='nodes' [connectors]='connectors'
  [getNodeDefaults]='nodeDefaults' [getConnectorDefaults]='connectorDefaults' [layout]='layout' ></ejs-diagram>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent {
  @ViewChild('diagram')
  public diagram!: DiagramComponent;

  //Initialize nodes
  public nodes = [
    { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
    { id: '2', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Input' }], style: { fill: '#6CA0DC' } },
    { id: '3', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
    { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
    { id: '5', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
    { id: '6', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '7', shape: { type: 'Flow', shape: 'Data' }, annotations: [{ content: 'Output' }], style: { fill: '#6CA0DC' } },
    { id: '8', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
  ];

  //Initialize connectors
  public connectors = [
    { id: 'connector1', sourceID: '1', targetID: '2' },
    { id: 'connector2', sourceID: '2', targetID: '3' },
    { id: 'connector3', sourceID: '3', targetID: '4', annotations: [{ content: 'No' }] },
    { id: 'connector4', sourceID: '3', targetID: '5', annotations: [{ content: 'Yes' }] },
    { id: 'connector5', sourceID: '5', targetID: '6' },
    { id: 'connector6', sourceID: '4', targetID: '7' },
    { id: 'connector7', sourceID: '6', targetID: '8' },
    { id: 'connector8', sourceID: '7', targetID: '8' }
  ];

  //Sets the default properties for all the Nodes
  public nodeDefaults(node: NodeModel): NodeModel {
    node.width = 120; node.height = 50;
    if ((node.shape as any).shape === 'Decision') {
      node.height = 80;
    }
    return node;
  };

  //Sets the default properties for all the Connector
  public connectorDefaults(connector: ConnectorModel): ConnectorModel {
    connector.type = 'Orthogonal';
    return connector;
  };

  //Uses layout to auto-arrange nodes on the Diagram page
  public layout: LayoutModel = {
    //Sets layout type
    type: 'Flowchart',

    //Customizes the flowchart layout
    flowchartLayoutSettings: {
      //Sets the yes branch direction
      yesBranchDirection: 'SameAsFlow',
      //Sets the no branch direction
      noBranchDirection: 'LeftInFlow',
    }

  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

The following table will explain the pictorial representation of the behavior:

YesBranchDirection NoBranchDirection TopToBottom LeftToRight
Left In Flow Right In Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Right In Flow Left In Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Same As Flow Right In Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Same As Flow Left In Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Right In Flow Same As Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Left In Flow Same As Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal
Same As Flow Same As Flow EJ2 Diagram displays Decision Output in Vertical EJ2 Diagram displays Decision Output in Horizontal

NOTE

If both branch directions are same, Yes branch will be prioritized.

Custom Yes and No branch values

The decision symbol produces two output branches: a Yes branch and a No branch. If the connector text value matches any value in the yesBranchValues property of the flowchartLayoutSettings class, it will be considered a Yes branch. Similarly, if the connector text value matches any value in the noBranchValues property, it will be considered a No branch. By default, the yesBranchValues property contains the string values Yes and True, while the noBranchValues property contains No and False.

Any text can be used as the connector text to describe the flow. Additionally, custom string values can be assigned to the yesBranchValues and noBranchValues properties. To direct the flow based on a conditional decision (if/else), the connector text must match a value in either the yesBranchValues or noBranchValues properties.

The following example shows how to set custom text to the yes branch and no branch values.

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, NodeModel, DiagramModule, DataBindingService, FlowchartLayoutService,
  ConnectorModel, Diagram, DataBinding, LayoutModel, FlowchartLayout } from '@syncfusion/ej2-angular-diagrams';

Diagram.Inject(DataBinding, FlowchartLayout);

@Component({
  imports: [DiagramModule],

  providers: [FlowchartLayoutService, DataBindingService],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="650px" [nodes]='nodes' [connectors]='connectors'
  [getNodeDefaults]='nodeDefaults' [getConnectorDefaults]='connectorDefaults' [layout]='layout' ></ejs-diagram>`,
  encapsulation: ViewEncapsulation.None
})


export class AppComponent {
  @ViewChild('diagram')
  public diagram!: DiagramComponent;

  //Initialize nodes
  public nodes = [
    { id: '1', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'Start' }], style: { fill: '#6CA0DC' } },
    { id: '2', shape: { type: 'Flow', shape: 'Decision' }, annotations: [{ content: 'Decision?' }], style: { fill: '#6CA0DC' } },
    { id: '3', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process1' }], style: { fill: '#6CA0DC' } },
    { id: '4', shape: { type: 'Flow', shape: 'Process' }, annotations: [{ content: 'Process2' }], style: { fill: '#6CA0DC' } },
    { id: '5', shape: { type: 'Flow', shape: 'Terminator' }, annotations: [{ content: 'End' }], style: { fill: '#6CA0DC' } }
  ];

  //Initialize connectors
  public connectors = [
    { id: 'connector1', sourceID: '1', targetID: '2' },
    { id: 'connector2', sourceID: '2', targetID: '3', annotations: [{ content: 'Reject' }] },
    { id: 'connector3', sourceID: '2', targetID: '4', annotations: [{ content: 'Accept' }] },
    { id: 'connector4', sourceID: '4', targetID: '5', },
  ];

  //Sets the default properties for all the Nodes
  public nodeDefaults(node: NodeModel): NodeModel {
    node.width = 120; node.height = 50;
    if ((node.shape as any).shape === 'Decision') {
      node.height = 80;
    }
    return node;
  };

  //Sets the default properties for all the Connector
  public connectorDefaults(connector: ConnectorModel): ConnectorModel {
    connector.type = 'Orthogonal';
    return connector;
  };

  //Uses layout to auto-arrange nodes on the Diagram page
  public layout: LayoutModel = {
    //Sets layout type
    type: 'Flowchart',

    //Customizes the flowchart layout
    flowchartLayoutSettings: {
      //Sets the yes branch values
      yesBranchValues: ["Yes", "Accept"],
      //Sets the no branch values
      noBranchValues: ["No", "Reject"]
    }
  }
  
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

EJ2 Flowchart layout diagram